【Golang】LeetCode 279. 完全平方数

279. 完全平方数

题目描述

思路

"完全平方数"是一道需要使用一维动态规划来解决的问题。具体来说,题目当中需要我们求的是最少需要多少个"完全平方数"能够凑出给出的数字n。我们可以使用dp数组来表示i对应的数字最少需要多少个"完全平方数"累加才能够得到。

现在问题转变为,我们如何求每一个数字最少需要多少个完全平方数来进行表示?我们应该从1开始,顺序地对dp数组进行维护。具体来说,针对dp[1]而言,显然它的值就是1,因为它本身就是一个完全平方数;针对i == 2,也就是dp[2],显然它的最优解是两个1,它的状态转移方程是dp[2] = dp[1] + 1。接下来我们枚举一个比较大的例子,比如i == 10,想要求dp[10],假设我们已经知道了dp[1...9]的值,我们使用变量j来表示完全平方数的数值,我们应该找dp[1...9]当中的最小值,这个最小值对应的下标i应该同时满足i + j * j == 10,此时的dp[i] + 1就是dp[10]的值。

基于以上的例子,我们不难推导出dp数组的状态转移方程。显然我们需要一个双重循环来对dp数组进行维护,最外层的循环变量i的值就是具体的数字,而第二层循环j,我们用它来表示完全平方数,必须满足j * j <= i。由此,dp[i] = min(dp[i - j * j]) + 1。

基于上述思路,我们就可以写代码来解决这道题了。

Golang 题解

go 复制代码
func numSquares(n int) int {
    // 返回和为 n 的完全平方数的最少数量
    dp := make([]int, n + 1)
    
    for i := 1; i <= n; i ++ {
        currMin := math.MaxInt
        for j := 1; j * j <= i; j ++ {
            currMin = min(currMin, dp[i - j * j] + 1)
        }
        dp[i] = currMin
    }

    return dp[n]
}
相关推荐
hetao173383734 分钟前
2026-10-03~04 hetao1733837 的刷题记录
c++·算法
Zootopia6261 小时前
飞行力学知识梳理1|飞行性能与稳定性
人工智能·python·算法·机器学习·无人机·学习方法·信息与通信
longlongzihan1 小时前
从LeetCode 70. 爬楼梯看动态规划:如何精准推导状态转移方程?
c++·算法·leetcode·动态规划
2601_960356382 小时前
2027校招采购岗解析:数学基础如何迁移到需求预测、成本与供应商分析
人工智能·算法
h_a_o777oah3 小时前
【树论】树链剖分:将树形结构转化为线性结构以处理树上路径问题(洛谷 P3384 附C++代码模板)
数据结构·算法·线段树·acm·树链剖分·树论·重链剖分
HEJOO93 小时前
指针的算术运算详解
java·数据结构·算法
Coder-magician3 小时前
《代码随想录》刷题打卡day47:并查集-part01
数据结构·算法·图论
垆边人似月.3 小时前
VLAN 资源池(100~200 分档)
数据结构·算法
潼心1412o4 小时前
C++初阶(长期更新)第6讲:类和对象(下)
开发语言·c++·算法
星光开发者4 小时前
基于决策树随机森林算法的小说推荐系统的设计与实现-计算机毕设【课程设计】78485
vue.js·算法·微信小程序·django·php·课程设计·express